
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1


// Brokers standard time zone (EST):

extern int Broker_standard_time_zone = +2;
extern bool mouse = false;
datetime Broker_DST_start     = D'01.01.2001 00:00:00';
datetime Broker_DST_end       = D'01.01.2001 00:00:00';
color Clock_color = DarkGray;
color font_color = DarkGray;
string font_name = "Tahoma";
extern int font_size = 8;

extern int Number_of_days_display_sessions = 5;
extern int Session_rectangle_line_style = STYLE_SOLID;
extern int Session_rectangle_line_width = 1;

extern string Customized_time_lines = ""; // Example: "12:34,21:43"



// Time of sessions and DST (Daylight saving time) - all in UTC

// south hemisphere
// Shanghai). EDT (Eastern Daylight Time) UTC offset +11 . 
int ShanghaiTimeZone = +11;
datetime ShanghaiBegins     = D'01.01.2001 01:30:00';
datetime ShanghaiEnds       = D'01.01.2001 07:00:00';
extern color ShanghaiColor = Teal;

// Wellington). EDT (Eastern Daylight Time) UTC offset +12 . 
int WellingtonTimeZone = +12;
datetime WellingtonBegins     = D'01.01.2001 22:00:00';
datetime WellingtonEnds       = D'02.01.2001 04:45:00';
extern datetime WellingtonDSTStarts  = D'30.09.2012 02:00:00';
extern datetime WellingtonDSTEnds    = D'07.04.2013 02:00:00';
extern color WellingtonColor = Teal;

// Sydney. EDT (Eastern Daylight Time) UTC offset +10 DST +1 hour. 
int SydneyTimeZone = +10;
datetime SydneyBegins      = D'02.01.2001 00:00:00'; //++
datetime SydneyEnds        = D'02.01.2001 06:00:00';
extern datetime SydneyDSTStarts   = D'07.10.2012 02:00:00';
extern datetime SydneyDSTEnds     = D'07.04.2013 02:00:00';
extern color SydneyColor = DarkSeaGreen;

// north hemisphere
int TokyoTimeZone = +9;
datetime TokyoBegins       = D'01.01.2001 00:00:00'; //+
datetime TokyoEnds         = D'01.01.2001 06:00:00'; //+
extern color TokyoColor = DarkSlateGray;

// Singapore, Shanghai Standard time zone:	UTC +8 hours No DST in 2009
int SingaporeTimeZone = +8;
datetime SingaporeBegins    = D'01.01.2001 01:00:00';
datetime SingaporeEnds      = D'01.01.2001 09:00:00';
extern color SingaporeColor = Maroon;

// Moscow, MSK (Moscow Standard Time) UTC +3 Daylight saving time:	+1 hour
int MoscowTimeZone = +3;
datetime MoscowBegins    = D'01.01.2001 06:00:00';
datetime MoscowEnds      = D'01.01.2001 14:45:00';
extern color MoscowColor = Tomato;

// CEST, UTC +1 Daylight saving time:	+1 hour
int FrankfurtTimeZone = +1;
extern datetime FrankfurtDSTStarts= D'31.03.2013 01:00:00';
extern datetime FrankfurtDSTEnds  = D'28.10.2012 02:00:00';
datetime FrankfurtBegins   = D'01.01.2001 08:00:00';
datetime FrankfurtEnds     = D'01.01.2001 16:30:00';
extern color FrankfurtColor = Sienna;

// GMT, UTC no offset Daylight saving time:	+1 hour
int LondonTimeZone = 0;
extern datetime LondonDSTStarts   = D'31.03.2013 01:00:00';
extern datetime LondonDSTEnds     = D'28.10.2012 02:00:00';
datetime LondonBegins      = D'01.01.2001 08:00:00';
datetime LondonEnds        = D'01.01.2001 16:30:00'; //+
extern color LondonColor = SaddleBrown;

// EST, UTC -5 Daylight saving time:	+1 hour
int NewYorkTimeZone = -5;
datetime NewYorkBegins     = D'01.01.2001 14:30:00'; //+
datetime NewYorkEnds       = D'01.01.2001 21:00:00';
extern datetime NewYorkDSTStarts  = D'10.03.2013 02:00:00';
extern datetime NewYorkDSTEnds    = D'04.11.2012 02:00:00';
extern color NewYorkColor = DarkOliveGreen;

// CDT, UTC -6 Daylight saving time:	+1 hour
int ChicagoTimeZone = -6;
datetime ChicagoBegins     = D'01.01.2001 14:30:00';
datetime ChicagoEnds       = D'01.01.2001 21:00:00';
extern datetime ChicagoDSTStarts  = D'10.03.2013 03:00:00';
extern datetime ChicagoDSTEnds    = D'04.11.2012 01:00:00';
extern color ChicagoColor = DarkOliveGreen;



datetime HistoryDownloadTime = 0;
datetime daily[];
int win = 0;
double open  = 0;
double high  = 0;
double low   = 0;
double close = 0;
bool SleepMode = false;

bool SessionRectangleOn = false;
string Short_name = "TIME III"; 

int init()
{
   HistoryDownloadTime = 0;
   
   IndicatorShortName("TIME III");
   
   //     :
   if (!GlobalVariableCheck("state " + Symbol() + "Sessions rectangle On"))
      GlobalVariableSet("state " + Symbol() + "Sessions rectangle On", 1);

   return(0);
}


int deinit()
{
   ProcessOptions();
   ClockClose();
   SessionsClose();
   
   return(0);
}


int start()
{
   win = WindowFind(Short_name);
   AllDraw();
   
   return(0);
}


//      
//
void AllDraw()
{
   //   
   if (HistoryDownloadTime < TimeCurrent() - 3600)
   {
      CopySeries(daily, MODE_TIME, Symbol(), PERIOD_D1);
      HistoryDownloadTime = TimeCurrent();
   }
   
   ProcessOptions();
   ClockDraw();
   SessionsDraw(Number_of_days_display_sessions - 1, 0);
}


void ProcessOptions()
{
   // >> Drag and Drop   
   
   SessionRectangleOn = GlobalVariableGet("state " + Symbol() + "Sessions rectangle On");

   string mousename = "  "; // Drag and Drop
   string rectname = "  /"; // Session rectangle On/Off
   
   int mouseX = ObjectGet(mousename, OBJPROP_XDISTANCE);
   int mouseY = ObjectGet(mousename, OBJPROP_YDISTANCE);
   int rectX  = ObjectGet(rectname, OBJPROP_XDISTANCE);
   int rectY  = ObjectGet(rectname, OBJPROP_YDISTANCE);
   
   if (MathAbs(mouseX - rectX) < 12 && MathAbs(mouseY - rectY) < 12)
   {
      SessionRectangleOn = !SessionRectangleOn;
      GlobalVariableSet("state " + Symbol() + "Sessions rectangle On", SessionRectangleOn);
   }
   
   int obj_total = ObjectsTotal();
   for(int obj = obj_total - 1; obj >= 0; obj--)
   {  
      string objname = ObjectName(obj);
      if (objname == mousename
      || objname == rectname)
         ObjectDelete(objname);
   }

   ObjectCreate(mousename, OBJ_LABEL, win, 0, 0);
   ObjectSet(mousename, OBJPROP_BACK, false);
   ObjectSet(mousename, OBJPROP_CORNER, 1);
   ObjectSet(mousename, OBJPROP_XDISTANCE, 5);
   ObjectSet(mousename, OBJPROP_YDISTANCE, 4);
   ObjectSetText(mousename, "8", 14, "Wingdings", DarkGray);
   
   ObjectCreate(rectname, OBJ_LABEL, win, 0, 0);
   ObjectSet(rectname, OBJPROP_BACK, true);
   ObjectSet(rectname, OBJPROP_CORNER, 1);
   ObjectSet(rectname, OBJPROP_XDISTANCE, 2);
   ObjectSet(rectname, OBJPROP_YDISTANCE, 28);
   if (SessionRectangleOn) 
      string cha = CharToStr(164);
   else
      cha = CharToStr(161);
   ObjectSetText(rectname, cha, 14, "Wingdings", DarkGray);
   
   // << Drag and Drop   
}


//  
//
void ClockDraw()
{
   ClockClose();
 
   int minutelocal = TimeMinute(TimeLocal());
   int minuteserver = TimeMinute(TimeCurrent());
   bool nobacklog = MathAbs(minuteserver - minutelocal) < 3 || (MathAbs(minuteserver - minutelocal) > 57);
   if (nobacklog)
      color clockcolor = Clock_color;
   else
      clockcolor = Red;
   
   datetime UTC = LocalTimeToUTC(TimeCurrent(), Broker_standard_time_zone, Broker_DST_start, Broker_DST_end);
   string clockUTC = "Time UTC";
   ObjectCreate(clockUTC, OBJ_LABEL, win, 0, 0);
   ObjectSet(clockUTC, OBJPROP_BACK, false);
   ObjectSet(clockUTC, OBJPROP_CORNER, 1);
   ObjectSet(clockUTC, OBJPROP_XDISTANCE, 125);
   ObjectSet(clockUTC, OBJPROP_YDISTANCE, 3);
   ObjectSetText(clockUTC, TimeToStr(UTC, TIME_MINUTES), 12, "System", clockcolor);

   string clock = "Time Broker";
   ObjectCreate(clock, OBJ_LABEL, win, 0, 0);
   ObjectSet(clock, OBJPROP_BACK, false);
   ObjectSet(clock, OBJPROP_CORNER, 1);
   ObjectSet(clock, OBJPROP_XDISTANCE, 80); // 30
   ObjectSet(clock, OBJPROP_YDISTANCE, 3); // 23
   //ObjectSetText(clock, TimeToStr(TimeCurrent(), TIME_MINUTES), 14, "Terminal", clockcolor);
   ObjectSetText(clock, TimeToStr(TimeCurrent(), TIME_MINUTES), 12, "System", clockcolor);

   string local = "Time Local";
   ObjectCreate(local, OBJ_LABEL, win, 0, 0);
   ObjectSet(local, OBJPROP_BACK, false);
   ObjectSet(local, OBJPROP_CORNER, 1);
   ObjectSet(local, OBJPROP_XDISTANCE, 35); // 30
   ObjectSet(local, OBJPROP_YDISTANCE, 3); // 43
   ObjectSetText(local, TimeToStr(TimeLocal(), TIME_MINUTES), 12, "System", Clock_color);
////////////////////////////////////////////////////////////////   
   string cursor = "Cursor";
   ObjectCreate(cursor, OBJ_VLINE, win, TimeCurrent(), 0);
   ObjectSet(cursor, OBJPROP_BACK, true);
   ObjectSet(cursor, OBJPROP_COLOR, Green);
   ObjectSet(cursor, OBJPROP_STYLE, STYLE_DOT);
   ObjectSet(cursor, OBJPROP_WIDTH, 1);
   
}


//     
//
void ClockClose()
{
   int obj_total = ObjectsTotal();
   for(int obj = obj_total - 1; obj >= 0; obj--)
   {  
      string objname = ObjectName(obj);
      if (StringFind(objname, "Time UTC") >= 0
      || StringFind(objname, "Time Broker") >= 0
      || StringFind(objname, "Time Local") >= 0
      || StringFind(objname, "Cursor") >= 0)
         ObjectDelete(objname);
   }
}


//       
//
// barshiftD1from -      
// barshiftD1to -      
//
void SessionsDraw(int barshiftD1from, int barshiftD1to)
{
   SessionsClose();
   
   //    M30  :
   SleepMode = Period() > PERIOD_M15;
   if (SleepMode)
   {
      string status = "Sleep mode";
      ObjectCreate(status, OBJ_LABEL, win, 0, 0);
      ObjectSet(status, OBJPROP_BACK, true);
      ObjectSet(status, OBJPROP_CORNER, 3);
      ObjectSet(status, OBJPROP_XDISTANCE, 2);
      ObjectSet(status, OBJPROP_YDISTANCE, 2);
      ObjectSetText(status, "", 8, "Tahoma", font_color);
   }
   
   //      H4:
   if (Period() >= PERIOD_H4)
      return;

   barshiftD1from = MathMax(0, barshiftD1from);
   barshiftD1to = MathMax(0, barshiftD1to);
   
   for (int daybarshift = barshiftD1from; daybarshift >= barshiftD1to; daybarshift--)
   {
      //  :
      datetime day = iTime(NULL, PERIOD_D1, daybarshift);
      string idstring = TimeToStr(day, TIME_DATE);
      
      if (day == 0)
         continue;
      
      //        ,      .
      
      //   Wellington
      datetime WellingtonSessionBeginUTC = TimeTableToUTC(day, WellingtonBegins, WellingtonDSTStarts, WellingtonDSTEnds);
      datetime WellingtonSessionBegin = UTCToLocalTime(WellingtonSessionBeginUTC, Broker_standard_time_zone, Broker_DST_start, Broker_DST_end) - 24*3600;
      datetime WellingtonSessionEndUTC = TimeTableToUTC(day, WellingtonEnds, WellingtonDSTStarts, WellingtonDSTEnds);
      datetime WellingtonSessionEnd = UTCToLocalTime(WellingtonSessionEndUTC, Broker_standard_time_zone, Broker_DST_start, Broker_DST_end);
      OHLC(WellingtonSessionBegin, WellingtonSessionEnd);
      PlaceRectangle("Wellington " + idstring, "Wellington", WellingtonSessionBeginUTC - WellingtonSessionBegin, WellingtonSessionBegin,0, WellingtonSessionEnd,0, WellingtonColor,0, 4);
      
      //    ,  :
      if (TimeDayOfYear(day) == DayOfYear() && DayOfWeek() != 5)
      {
         WellingtonSessionBeginUTC = TimeTableToUTC(day, WellingtonBegins, WellingtonDSTStarts, WellingtonDSTEnds);
         WellingtonSessionBegin = UTCToLocalTime(WellingtonSessionBeginUTC, Broker_standard_time_zone, Broker_DST_start, Broker_DST_end);
         WellingtonSessionEndUTC = TimeTableToUTC(day, WellingtonEnds, WellingtonDSTStarts, WellingtonDSTEnds);// + 24*3600;
         WellingtonSessionEnd = UTCToLocalTime(WellingtonSessionEndUTC, Broker_standard_time_zone, Broker_DST_start, Broker_DST_end);
         OHLC(WellingtonSessionBegin, WellingtonSessionEnd);
         PlaceRectangle("Wellington " + idstring + ".", "Wellington", WellingtonSessionBeginUTC - WellingtonSessionBegin, WellingtonSessionBegin,0, WellingtonSessionEnd,0, WellingtonColor,0, 4);
      }
      
      // 
      datetime SydneySessionBeginUTC = TimeTableToUTC(day, SydneyBegins, SydneyDSTStarts, SydneyDSTEnds);
      datetime SydneySessionBegin = UTCToLocalTime(SydneySessionBeginUTC, Broker_standard_time_zone, Broker_DST_start, Broker_DST_end);
      datetime SydneySessionEnd = SydneySessionBegin + (SydneyEnds - SydneyBegins);
      OHLC(SydneySessionBegin, SydneySessionEnd);
      PlaceRectangle("Sydney " + idstring, "Sydney", SydneySessionBeginUTC - SydneySessionBegin, SydneySessionBegin,0, SydneySessionEnd,0, SydneyColor,0, 3);
      

      //  
      datetime TokyoSessionBeginUTC = TimeTableToUTC(day, TokyoBegins, 0, 0);
      datetime TokyoSessionBegin = UTCToLocalTime(TokyoSessionBeginUTC, Broker_standard_time_zone, Broker_DST_start, Broker_DST_end);
      datetime TokyoSessionEnd = TokyoSessionBegin + (TokyoEnds - TokyoBegins);
      OHLC(TokyoSessionBegin, TokyoSessionEnd);
      PlaceRectangle("Tokyo " + idstring, "Tokyo", TokyoSessionBeginUTC - TokyoSessionBegin, TokyoSessionBegin,0, TokyoSessionEnd,0, TokyoColor,0, 2);
      
      //  
      datetime SingaporeSessionBeginUTC = TimeTableToUTC(day, SingaporeBegins, 0, 0);
      datetime SingaporeSessionBegin = UTCToLocalTime(SingaporeSessionBeginUTC, Broker_standard_time_zone, Broker_DST_start, Broker_DST_end);
      datetime SingaporeSessionEnd = SingaporeSessionBegin + (SingaporeEnds - SingaporeBegins);
      OHLC(SingaporeSessionBegin, SingaporeSessionEnd);
      PlaceRectangle("Singapore " + idstring, "Singapore", SingaporeSessionBeginUTC - SingaporeSessionBegin, SingaporeSessionBegin,0, SingaporeSessionEnd,0, SingaporeColor,0, 1);
      
      // 
      datetime ShanghaiSessionBeginUTC = TimeTableToUTC(day, ShanghaiBegins, 0, 0);
      datetime ShanghaiSessionBegin = UTCToLocalTime(ShanghaiSessionBeginUTC, Broker_standard_time_zone, Broker_DST_start, Broker_DST_end);
      datetime ShanghaiSessionEnd = ShanghaiSessionBegin + (ShanghaiEnds - ShanghaiBegins);
      OHLC(ShanghaiSessionBegin, ShanghaiSessionEnd);
      PlaceRectangle("Shanghai " + idstring, "Shanghai", ShanghaiSessionBeginUTC - ShanghaiSessionBegin, ShanghaiSessionBegin,0, ShanghaiSessionEnd,0, ShanghaiColor,0, 0);
      
      // 
      datetime MoscowSessionBeginUTC = TimeTableToUTC(day, MoscowBegins, 0, 0);
      datetime MoscowSessionBegin = UTCToLocalTime(MoscowSessionBeginUTC, Broker_standard_time_zone, Broker_DST_start, Broker_DST_end);
      datetime MoscowSessionEnd = MoscowSessionBegin + (MoscowEnds - MoscowBegins);
      OHLC(MoscowSessionBegin, MoscowSessionEnd);
      PlaceRectangle("Moscow " + idstring, "Moscow", MoscowSessionBeginUTC - MoscowSessionBegin, MoscowSessionBegin,0, MoscowSessionEnd,0, MoscowColor,0, 4);
      
      
      // 
      datetime FrankfurtSessionBeginUTC = TimeTableToUTC(day, FrankfurtBegins, FrankfurtDSTStarts, FrankfurtDSTEnds);
      datetime FrankfurtSessionBegin = UTCToLocalTime(FrankfurtSessionBeginUTC, Broker_standard_time_zone, Broker_DST_start, Broker_DST_end);
      datetime FrankfurtSessionEnd = FrankfurtSessionBegin + (FrankfurtEnds - FrankfurtBegins);
      OHLC(FrankfurtSessionBegin, FrankfurtSessionEnd);
      PlaceRectangle("Frankfurt " + idstring, "Frankfurt, Zurich", FrankfurtSessionBeginUTC - FrankfurtSessionBegin, FrankfurtSessionBegin,0, FrankfurtSessionEnd,0, FrankfurtColor,0, 3);

      // 
      datetime LondonSessionBeginUTC = TimeTableToUTC(day, LondonBegins, LondonDSTStarts, LondonDSTEnds);
      datetime LondonSessionBegin = UTCToLocalTime(LondonSessionBeginUTC, Broker_standard_time_zone, Broker_DST_start, Broker_DST_end);
      datetime LondonSessionEnd = LondonSessionBegin + (LondonEnds - LondonBegins);
      OHLC(LondonSessionBegin, LondonSessionEnd);
      PlaceRectangle("London " + idstring, "London", LondonSessionBeginUTC - LondonSessionBegin, LondonSessionBegin, low, LondonSessionEnd, high, LondonColor,0, 2);

      // -
      datetime NewYorkSessionBeginUTC = TimeTableToUTC(day, NewYorkBegins, NewYorkDSTStarts, NewYorkDSTEnds);
      datetime NewYorkSessionBegin = UTCToLocalTime(NewYorkSessionBeginUTC, Broker_standard_time_zone, Broker_DST_start, Broker_DST_end);
      datetime NewYorkSessionEnd = NewYorkSessionBegin + (NewYorkEnds - NewYorkBegins);
      OHLC(NewYorkSessionBegin, NewYorkSessionEnd);
      PlaceRectangle("NewYork " + idstring, "New York", NewYorkSessionBeginUTC - NewYorkSessionBegin, NewYorkSessionBegin, low, NewYorkSessionEnd, high, NewYorkColor,0, 1);

      // 
      datetime ChicagoSessionBeginUTC = TimeTableToUTC(day, ChicagoBegins, ChicagoDSTStarts, ChicagoDSTEnds);
      datetime ChicagoSessionBegin = UTCToLocalTime(ChicagoSessionBeginUTC, Broker_standard_time_zone, Broker_DST_start, Broker_DST_end);
      datetime ChicagoSessionEnd = ChicagoSessionBegin + (ChicagoEnds - ChicagoBegins);
      OHLC(ChicagoSessionBegin, ChicagoSessionEnd);
      PlaceRectangle("Chicago " + idstring, "Chicago, Toronto", ChicagoSessionBeginUTC - ChicagoSessionBegin, ChicagoSessionBegin,0, ChicagoSessionEnd,0, ChicagoColor,0, 0);
      
      // 
      datetime OceaniaSessionBeginUTC = WellingtonSessionBeginUTC;
      datetime OceaniaSessionBegin = WellingtonSessionBegin;
      datetime OceaniaSessionEnd = SydneySessionEnd;
      OHLC(OceaniaSessionBegin, OceaniaSessionEnd);
      PlaceRectangle1("Oceania " + idstring,"", OceaniaSessionBeginUTC - OceaniaSessionBegin, OceaniaSessionBegin, low, OceaniaSessionEnd, high, WellingtonColor, 0, -1);
      
      // 
      datetime AsiaSessionBeginUTC = TokyoSessionBeginUTC;
      datetime AsiaSessionBegin = TokyoSessionBegin;
      datetime AsiaSessionEnd = SingaporeSessionEnd;
      OHLC(AsiaSessionBegin, AsiaSessionEnd);
      PlaceRectangle1("Asia " + idstring,"", AsiaSessionBeginUTC - AsiaSessionBegin, AsiaSessionBegin, low, AsiaSessionEnd, high, TokyoColor, 0, -1);
      
      // 
      datetime EuropeSessionBeginUTC = LondonSessionBeginUTC;
      datetime EuropeSessionBegin = LondonSessionBegin;
      datetime EuropeSessionEnd = LondonSessionEnd;
      OHLC(EuropeSessionBegin, EuropeSessionEnd);
      PlaceRectangle1("Europe " + idstring,"", EuropeSessionBeginUTC - EuropeSessionBegin, EuropeSessionBegin, low, EuropeSessionEnd, high, LondonColor, 0, -1);
      
      // 
      datetime USASessionBeginUTC = NewYorkSessionBeginUTC;
      datetime USASessionBegin = NewYorkSessionBegin;
      datetime USASessionEnd = NewYorkSessionEnd;
      OHLC(USASessionBegin, USASessionEnd);
      PlaceRectangle1("USA " + idstring,"", USASessionBeginUTC - USASessionBegin, USASessionBegin, low, USASessionEnd, high, NewYorkColor, 0, -1);
      
      
      
      
      
      
      // Customized line
      int fragments = FragmentsTotal(Customized_time_lines);
      for(int f = 0; f < fragments; f++)
      {
         string fragment = StringTrimRight(GetFragment(Customized_time_lines, f));
         if (!EmptyString(fragment))
         {
            datetime time = UTCToLocalTime(StrToTime(TimeToStr(day,TIME_DATE) + " " + fragment), Broker_standard_time_zone, Broker_DST_start, Broker_DST_end);

            if (time > 0)
            {
               string lineid = "Customized line " + idstring + " " + ShortestTime(time);
               ObjectCreate(lineid, OBJ_VLINE, 0, time, 0);
               ObjectSet(lineid, OBJPROP_COLOR, DeepPink);
               ObjectSet(lineid, OBJPROP_BACK, 1);
               ObjectSet(lineid, OBJPROP_STYLE, STYLE_DOT);
               ObjectSetText(lineid, fragment);

            }
         }
      }

      // Australian Securities Exchange (ASX)
      PlaceImportantPointsUTC(TimeTableToUTC(day, 0, 0, 0), 0, 0);
     }   
}


//       
//
void SessionsClose()
{
   int obj_total = ObjectsTotal();
   for(int obj = obj_total - 1; obj >= 0; obj--)
   {  
      string objname = ObjectName(obj);
      if (StringFind(objname, " Session Begin") >= 0
      || StringFind(objname, " Session End") >= 0
      || StringFind(objname, " Session High") >= 0
      || StringFind(objname, " Session Low") >= 0
      || StringFind(objname, " Session label") >= 0
      || StringFind(objname, " Session line") >= 0
      || StringFind(objname, " UTC ") >= 0
      || StringFind(objname, "_UTC ") >= 0
      || StringFind(objname, " Session time") >= 0
      || StringFind(objname, "Customized line") >= 0
      || StringFind(objname, "Sleep mode") >= 0)
            ObjectDelete(objname);
   }
}


//   
void PlaceRectangle1(string session, string description, int toUTC, datetime time1, double price1, datetime time2, double price2, color session_color, color rect_color, int level)
{
   if (time2 < time1 || time2 > time1 + 12*3600)
      return;
   
   double Y = WindowPriceMin(win) + (WindowPriceMax(win) - WindowPriceMin(win)) * (0.78 - level*0.15);
   
   if (SessionRectangleOn && mouse)
   {
      //     
      
      string objname = session + " Session High";
      ObjectCreate(objname, OBJ_TREND, 0, time1, price2, time2, price2);
      ObjectSet(objname, OBJPROP_COLOR, session_color);
      ObjectSet(objname, OBJPROP_BACK, true);
      ObjectSet(objname, OBJPROP_STYLE, Session_rectangle_line_style);
      ObjectSet(objname, OBJPROP_WIDTH, Session_rectangle_line_width);
      ObjectSet(objname, OBJPROP_RAY, 0);

      objname = session + " Session Low";
      ObjectCreate(objname, OBJ_TREND, 0, time1, price1, time2, price1);
      ObjectSet(objname, OBJPROP_COLOR, session_color);
      ObjectSet(objname, OBJPROP_BACK, true);
      ObjectSet(objname, OBJPROP_STYLE, Session_rectangle_line_style);
      ObjectSet(objname, OBJPROP_WIDTH, Session_rectangle_line_width);
      ObjectSet(objname, OBJPROP_RAY, 0);

      objname = session + " Session Begin";
      ObjectCreate(objname, OBJ_TREND, 0, time1, price2, time1, price1);
      ObjectSet(objname, OBJPROP_COLOR, session_color);
      ObjectSet(objname, OBJPROP_BACK, true);
      ObjectSet(objname, OBJPROP_STYLE, Session_rectangle_line_style);
      ObjectSet(objname, OBJPROP_WIDTH, Session_rectangle_line_width);
      ObjectSet(objname, OBJPROP_RAY, 0);

      objname = session + " Session End";
      ObjectCreate(objname, OBJ_TREND, 0, time2, price1, time2, price2);
      ObjectSet(objname, OBJPROP_COLOR, session_color);
      ObjectSet(objname, OBJPROP_BACK, true);
      ObjectSet(objname, OBJPROP_STYLE, Session_rectangle_line_style);
      ObjectSet(objname, OBJPROP_WIDTH, Session_rectangle_line_width);
      ObjectSet(objname, OBJPROP_RAY, 0);

   }
   }
//
//
void PlaceRectangle(string session, string description, int toUTC, datetime time1, double price1, datetime time2, double price2, color session_color, color rect_color, int level)
{
   if (time2 < time1 || time2 > time1 + 12*3600)
      return;
   
   double Y = WindowPriceMin(win) + (WindowPriceMax(win) - WindowPriceMin(win)) * (0.78 - level*0.15);
 
   if (!SleepMode)
   {
      //     
      string objname = session + " Session line";
      ObjectCreate(objname, OBJ_TREND, win, time1, Y, time2, Y);
      ObjectSet(objname, OBJPROP_COLOR, session_color);
      ObjectSet(objname, OBJPROP_BACK, true);
      ObjectSet(objname, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(objname, OBJPROP_WIDTH, 2);
      ObjectSet(objname, OBJPROP_RAY, 0);
   
      objname = session + " Session label";
      ObjectCreate(objname, OBJ_TEXT, win, time1 + 200 * 60, Y);
      ObjectSet(objname, OBJPROP_BACK, false);
      ObjectSetText(objname, description, font_size, font_name, font_color);

   }   
}


void PlaceImportantPointsUTC(datetime UTC, string text, string description)
{
   if (SleepMode)
      return;

   datetime time = UTCToLocalTime(UTC, Broker_standard_time_zone, Broker_DST_start, Broker_DST_end);

   string search = TimeToStr(UTC, TIME_DATE | TIME_MINUTES) + " UTC ";
   string objname = "";

   //       :
   int obj_total = ObjectsTotal();
   for(int obj = obj_total - 1; obj >= 0; obj--)
   {  
      if (StringFind(ObjectName(obj), search) >= 0)
      {
         objname = ObjectName(obj);
         break;
      }
   }

   //      ,   :
   if (objname == search || objname == "")
   {
      if (objname != "")
         ObjectDelete(objname);
      objname = StringSubstr(search + text, 0, 63);
   }
   else if (StringLen(objname) + StringLen(text) < 62)
   {
      ObjectDelete(objname);
      objname = StringSubstr(objname + ", " + text, 0, 63);
   }
   //   ,     :
   else
   {
      datetime newtime = time + Period()*60;
      string newobjname = StringSubstr(TimeToStr(UTC + Period()*60, TIME_DATE | TIME_MINUTES) + " UTC " + text, 0, 63);
      ObjectCreate(newobjname, OBJ_VLINE, win, 0, 0);
      ObjectSet(newobjname, OBJPROP_TIME1, newtime);
      ObjectSet(newobjname, OBJPROP_COLOR, DarkGray);
      ObjectSet(newobjname, OBJPROP_BACK, false);
      ObjectSet(newobjname, OBJPROP_STYLE, STYLE_DOT);
      ObjectSet(newobjname, OBJPROP_WIDTH, 1);
      ObjectSetText(newobjname, "");
   }

   ObjectSetText(objname, ShortTime(UTC));
   
   string markname = StringSetChar(objname, StringFind(objname, " UTC "), 95);
   int barshift = iBarShift(NULL, 0, time);
   low = MathMin(MathMin(Low[barshift], Low[barshift + 1]), Low[barshift - 1]);
   if (low < 0.1)
      low = Bid;

}



//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//      
//


bool EmptyString(string str)
{
   return(StringLen(StringTrimRight(str)) == 0);
}

int FragmentsTotal(string text)
{
   int strlen = StringLen(text);
   int total = 0;
   for(int i = 0; i < strlen; i++)
   if (StringFind(";,|/", StringSubstr(text, i, 1)) >= 0)
      total++;
   return(total+1);
}

string GetFragment(string text, int number)
{
   int start = 0;
   int strlen = StringLen(text);
   
   if (number != 0)
   {
      
      int curnumber = 0;
      for(int i = 0; i < strlen; i++)
         if (StringFind(";,|/", StringSubstr(text, i, 1)) >= 0)
         {
            curnumber++;
            if (curnumber >= number)
            {
               start = i+1;
               break;
            }
         }
   }

   int end = start;
   while(end < strlen && StringFind(";,|/", StringSubstr(text, end, 1)) < 0)
      end++;

   return(StringSubstr(text, start, end-start));
}


void CopySeries(datetime& array[], int MODE, string SYMBOL, int PERIOD)
{
   ArrayCopySeries(array, MODE, SYMBOL, PERIOD);
   int lasterror = GetLastError();
   if (lasterror == 4066) // ERR_HISTORY_WILL_UPDATED
   {
      int attempt = 0;
      while(lasterror == 4066 && attempt < 10)
      {
         Sleep(5000);
         ArrayCopySeries(array, MODE, SYMBOL, PERIOD);
         lasterror = GetLastError();
      }
   }
}


void OHLC(datetime fromtime, datetime totime)
{
   int barshiftfrom = iBarShift(NULL, PERIOD_H1, fromtime);
   int barshiftto = iBarShift(NULL, PERIOD_H1, totime-1);
   int highestbarshift = iHighest(NULL, PERIOD_H1, MODE_HIGH, barshiftfrom - barshiftto + 1, barshiftto);
   high = iHigh(NULL, PERIOD_H1, highestbarshift);
   int lowestbarshift = iLowest(NULL, PERIOD_H1, MODE_LOW, barshiftfrom - barshiftto + 1, barshiftto);
   low = iLow(NULL, PERIOD_H1, lowestbarshift);
}


datetime TimeTableToUTC(datetime date, datetime time, datetime DSTStarts, datetime DSTEnds)
{
   datetime UTC = StrToTime(TimeToStr(date, TIME_DATE) + " " + TimeHour(time) + ":" + TimeMinute(time) + ":" + TimeSeconds(time));
   if (DSTStarts <= DSTEnds)
   {
      if (UTC >= DSTStarts && UTC <= DSTEnds)
         UTC -= 3600;
   }
   else
   {
      if (!(UTC > DSTEnds && UTC < DSTStarts))
         UTC -= 3600;
   }
   return(UTC);
}


datetime LocalTimeToUTC(datetime time, int TimeZone, datetime DSTStarts, datetime DSTEnds)
{
   datetime UTC = time - TimeZone*3600;
   
   datetime timeyear = StrToTime("01.01." + TimeYear(UTC));
   datetime dstyear = StrToTime("01.01." + TimeYear(DSTStarts));
   datetime dststart = timeyear + DSTStarts - dstyear;
   datetime dstend = timeyear + DSTEnds - dstyear;
   
   if (DSTStarts <= DSTEnds && DSTStarts != 0)
   {
      if (UTC >= dststart && UTC <= dstend)
         UTC -= 3600;
   }
   else if (DSTStarts >= DSTEnds && DSTEnds != 0)
   {
      datetime endofyear = StrToTime("31.12." + TimeYear(dststart));

      if ((UTC >= timeyear && UTC <= dstend)
      || (UTC >= dststart && UTC <= endofyear))
         UTC -= 3600;
   }
   return(UTC);
}


datetime UTCToLocalTime(datetime UTC, int TimeZone, datetime DSTStarts, datetime DSTEnds)
{
   
   datetime timeyear = StrToTime("01.01." + TimeYear(UTC));
   datetime dstyear = StrToTime("01.01." + TimeYear(DSTStarts));
   datetime dststart = timeyear + DSTStarts - dstyear;
   datetime dstend = timeyear + DSTEnds - dstyear;
   
   if (DSTStarts <= DSTEnds && DSTStarts != 0)
   {
      if (UTC >= dststart && UTC <= dstend)
         UTC += 3600;
   }
   else if (DSTStarts >= DSTEnds && DSTEnds != 0)
   {
      datetime endofyear = StrToTime("31.12." + TimeYear(dststart));
      
      if ((UTC >= timeyear && UTC <= dstend)
      || (UTC >= dststart && UTC <= endofyear))
         UTC += 3600;
   }
   return(UTC + TimeZone*3600);
}


string ShortTime(datetime time)
{
   string shor = TimeToStr(time, TIME_MINUTES);
   if (StringSubstr(shor, 0, 1) == "0")
      return(StringSubstr(shor, 1));
   else
      return(shor);
}


string ShortestTime(datetime time)
{
   if (TimeMinute(time) == 0)
   {
      string shor = "";
      shor = TimeHour(time);
   }
   else
   {
      shor = TimeToStr(time, TIME_MINUTES);
      if (StringSubstr(shor, 0, 1) == "0")
         shor = StringSubstr(shor, 1);
   }
   
   return(shor);
}

